/*
 * Debugging ...
 */
function log(msg){
	if (window.console && console.log) {
 		console.log(msg); //for firebug
	}

	$("#logBox").append(msg); //log to container
}

// Gateway
var baseURL; 

/*
 * Mapping der JSON-Namen
 */
var jsonNames = {
  // Kesselparameter 
	VlTmpSoll: {name: "Vorlauftemperatur (Soll)", unit: "&deg;C"},
	VlTmp : {name: "Vorlauftemperatur", unit: "&deg;C"},
	RlTmp : {name: "R&uuml;cklauftemperatur", unit: "&deg;C"},
  KslLstMax: {name: "Kesselleistung (Max)", unit: "%"},
  KslLst: {name: "Kesselleistung", unit: "%"},
  WWTmp: {name: "Warmwassertemperatur", unit: "&deg;C"},
  WDruck: {name: "Wasserdruck", unit: "Bar"},
  FlStr: {name: "Flammenstrom", unit: "&micro;A"},
  SC: {name: "Service-Code", unit: ""},
  FC: {name: "Fehler-Code", unit: ""},
  Gs: {name: "Gasventil", unit: "", bool: true},
  Gbl: {name: "Gebl&auml;se", unit: "", bool: true},
  Znd: {name: "Z&uuml;ndung", unit: "", bool: true},
  PmpKsl: {name: "Kesselpumpe", unit: "", bool: true},
  PmpZrk: {name: "Zirkulationspumpe", unit: "", bool: true},
  DWgVnt: {name: "3-Wege-Ventil-WW", unit: "", bool: true},  
  
  // HK1Monitor  
	RaumTmpSoll: {name: "Raumtemperatur (Soll)", unit: "&deg;C"},
  RaumTmp:  {name: "Raumtemperatur", unit: "&deg;C"},
  RaumTmpDelta: {name: "Raumtemperatur Delta", unit: "K/min"},
  // UBAMonitorSlow  
  AnzBrSt: {name: "Betriebsstunden", unit: "h"},
  BetrZtHz: {name: "Betriebszeit heizen", unit: "min"},
  BetrZtKp: {name: "Betriebszeit komplett", unit: "min"},
  PumpMod: {name: "Pumpenmodulation", unit: "%"},
  AusTmp: {name: "Aussentemperatur", unit: "&deg;C"},
  KslTmp: {name: "Kesseltemperatur", unit: "&deg;C"},
  // UBAMonitorWW
	AnzWWBer:{name: "Warmwasserbereitungen", unit: ""},
  BetrZtWW: {name: "Betriebszeit Warmwasser", unit: "min"},
  WWTmpSoll: {name: "Warmwassertemperatur (Soll)", unit: "&deg;C"},
  
  AusTmpGed: {name: "Aussentemperatur ged&auml;mpft", unit: "&deg;C"}
};

/*
 * Eine Tabelle mit Daten vom EMS-Gateway fllen
 */
 function loadTable(url, name) {
	// Warte-Bild
	$(name).empty();
	$(name).append("<center><img src='css/themes/images/ajax-loader.gif'></center>");

	// Daten holen
	$.ajax({
		cache: false,
		url: url, 
		dataType: "json",
    success: function(data) {
      // Warte-Bild lschen
			$(name).empty();
			
			// Tabelle laden
			for(var propertyName in data) {
				log(jsonNames[propertyName]);
				var value;
				if (jsonNames[propertyName].bool == true) {
					if (data[propertyName] == 0) {
				  	value = "<img src='css/themes/images/off.png' alt='OFF' height='18' width='18'>";
					} else {
				  	value = "<img src='css/themes/images/on.png' alt='ON' height='18' width='18'> ";
				  }
				} else {
					value = data[propertyName];
				}
	   		$(name).append(
					 "<tr>"+
					 "<td class='ui-widget-content' width='70%'>" + jsonNames[propertyName].name + "</td>"+
					 "<td class='ui-widget-content' width='15%'>" + value + "</td>"+
					 "<td class='ui-widget-content' width='15%'>" + jsonNames[propertyName].unit + "</td>"+
					 "</tr>");
			}
		}
	});
}
 
/*
 * Hauptfunktion
 */
$(document).ready(function(){
		baseURL = $.jStorage.get("url", "##.json");
		
		// Callbacks fr aufklappbare Abschnitte
		$( "#warmwasser" ).bind('expand', function() {
			loadTable(baseURL.replace("##", "25"), "#Warmwasser");
		});
		$( "#kessel" ).bind('expand', function() {
			 loadTable(baseURL.replace("##", "24"), "#Kessel");	
		});
		$( "#betriebsdaten" ).bind('expand', function() {
			loadTable(baseURL.replace("##", "25"), "#Betriebsdaten");
		});
		$( "#heizkreis1" ).bind('expand', function() {
			loadTable(baseURL.replace("##", "62"), "#Heizkreis1");
		});
		$( "#aussentemperatur" ).bind('expand', function() {
			loadTable(baseURL.replace("##", "163"), "#Aussentemperatur");
		});

		// Buttons Optionsdialog
		$('#options').on("pageshow", function() {
    	$("#gwurl").val(baseURL);
		});
		$( "#break" ).click(function() {
			baseURL = $.jStorage.get("url", "##.json");			
		});
		$( "#reset" ).click(function() {
			baseURL = "http://192.168.0.2:8080/99?t=##";
			$("#gwurl").val(baseURL);			 
		});
		$( "#save" ).click(function() {
		  baseURL = $("#gwurl").val(); 
			$.jStorage.set("url", baseURL);
		});	
});

